package wtf.hak.survivalfabric.config;

import com.google.common.collect.Lists;
import net.minecraft.screen.GenericContainerScreenHandler;
import net.minecraft.screen.ScreenHandlerType;

import java.util.List;

public class Config {

    public String configVersion = "1.0";

    public boolean joinMessageEnabled = true;
    public String joinMessage = "§8[§a+§8] §7%s";

    public boolean quitMessageEnabled = true;
    public String quitMessage = "§8[§c-§8] §7%s";

    public boolean chatMessageEnabled = true;
    public String chatMessage = "§7%s§8:§f %s";

    public boolean dimensionIndicatorEnabled = true;
    public String overworldPrefix = "§8[§aOverworld§8] ";
    public String netherPrefix = "§8[§cNether§8] ";
    public String endPrefix = "§8[§dEnd§8] ";
    public String spectatorPrefix = "§8[§eSpectator§8] ";
    public String unknownPrefix = "§8[§7Unknown§8] ";

    public boolean sharedEnderChestEnabled = true;
    public String sharedEnderChestName = "Ender Chest";
    public int sharedEnderChestRows = 6;
    public boolean sharedEnderChestLimitedAccess = true;
    public List<String> sharedEnderChestNames = Lists.newArrayList("AlwaysHAK", "LunaticFox");

    public String inSlimeChunkMessage = "§aYou're currently in a slime chunk";
    public String notInSlimeChunkMessage = "§cYou're currently not in a slime chunk";

    public boolean veinMinerEnabled = true;
    public int maxVeinSize = 99999;

    public ScreenHandlerType<GenericContainerScreenHandler> screenHandlerType() {
        return switch (sharedEnderChestRows) {
            case 1 -> ScreenHandlerType.GENERIC_9X1;
            case 2 -> ScreenHandlerType.GENERIC_9X2;
            case 3 -> ScreenHandlerType.GENERIC_9X3;
            case 4 -> ScreenHandlerType.GENERIC_9X4;
            case 5 -> ScreenHandlerType.GENERIC_9X5;
            case 6 -> ScreenHandlerType.GENERIC_9X6;
            default -> ScreenHandlerType.GENERIC_9X3;
        };
    }
}